Add e2e tests for helm chart

This commit is contained in:
Manuel Alejandro de Brito Fontes 2020-04-15 20:26:08 -04:00
parent 42b3a1ebd2
commit 2b2acae28f
28 changed files with 152 additions and 1 deletions

View file

@ -261,6 +261,10 @@ misspell: check-go-version ## Check for spelling errors.
kind-e2e-test: check-go-version ## Run e2e tests using kind.
@test/e2e/run.sh
.PHONY: kind-e2e-chart-tests
kind-e2e-chart-tests: ## Run helm chart e2e tests
@test/e2e/run-chart-test.sh
.PHONY: run-ingress-controller
run-ingress-controller: ## Run the ingress controller locally using a kubectl proxy connection.
@build/run-ingress-controller.sh

View file

@ -1,4 +1,9 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: ClusterIP
config:
use-proxy-protocol: "true"

View file

@ -1,5 +1,8 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: NodePort
nodePorts:

View file

@ -1,6 +1,10 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
addHeaders:
X-Frame-Options: deny
proxySetHeaders:
X-Forwarded-Proto: https
service:
type: ClusterIP

View file

@ -1,4 +1,6 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: NodePort

View file

@ -1,5 +1,7 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: ClusterIP
tcp:

View file

@ -1,5 +1,7 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: ClusterIP

View file

@ -1,5 +1,9 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: ClusterIP
tcp:
9000: "default/test:8080"

View file

@ -1,2 +1,6 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: ClusterIP

View file

@ -1,4 +1,8 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
metrics:
enabled: true
service:
type: ClusterIP

View file

@ -1,5 +1,9 @@
controller:
kind: DaemonSet
admissionWebhooks:
enabled: false
service:
type: ClusterIP
podSecurityPolicy:
enabled: true

View file

@ -2,6 +2,8 @@ controller:
kind: DaemonSet
admissionWebhooks:
enabled: true
service:
type: ClusterIP
podSecurityPolicy:
enabled: true

View file

@ -2,3 +2,5 @@ controller:
kind: DaemonSet
admissionWebhooks:
enabled: true
service:
type: ClusterIP

View file

@ -1,3 +1,7 @@
controller:
autoscaling:
enabled: true
admissionWebhooks:
enabled: false
service:
type: ClusterIP

View file

@ -1,3 +1,7 @@
controller:
config:
use-proxy-protocol: "true"
admissionWebhooks:
enabled: false
service:
type: ClusterIP

View file

@ -1,4 +1,6 @@
controller:
admissionWebhooks:
enabled: false
service:
type: NodePort
nodePorts:

View file

@ -1 +1,4 @@
# Left blank to test default values
controller:
service:
type: ClusterIP

View file

@ -1,5 +1,9 @@
controller:
admissionWebhooks:
enabled: false
addHeaders:
X-Frame-Options: deny
proxySetHeaders:
X-Forwarded-Proto: https
service:
type: ClusterIP

View file

@ -1,3 +1,7 @@
controller:
admissionWebhooks:
enabled: false
metrics:
enabled: true
service:
type: ClusterIP

View file

@ -1,3 +1,5 @@
controller:
admissionWebhooks:
enabled: false
service:
type: NodePort

View file

@ -1,2 +1,6 @@
controller:
service:
type: ClusterIP
podSecurityPolicy:
enabled: true

View file

@ -1,4 +1,6 @@
controller:
admissionWebhooks:
enabled: false
service:
type: ClusterIP
tcp:

View file

@ -1,4 +1,6 @@
controller:
admissionWebhooks:
enabled: false
service:
type: ClusterIP

View file

@ -1,3 +1,7 @@
controller:
service:
type: ClusterIP
tcp:
9000: "default/test:8080"
9001: "default/test:8080"

View file

@ -1,6 +1,8 @@
controller:
admissionWebhooks:
enabled: true
service:
type: ClusterIP
podSecurityPolicy:
enabled: true

View file

@ -1,3 +1,5 @@
controller:
admissionWebhooks:
enabled: true
service:
type: ClusterIP

View file

@ -1,6 +1,14 @@
kind: Cluster
apiVersion: kind.sigs.k8s.io/v1alpha3
apiVersion: kind.x-k8s.io/v1alpha4
nodes:
- role: control-plane
- role: worker
- role: worker
kubeadmConfigPatches:
- |
kind: ClusterConfiguration
metadata:
name: config
controllerManager:
extraArgs:
namespace-sync-period: 10s

62
test/e2e/run-chart-test.sh Executable file
View file

@ -0,0 +1,62 @@
#!/bin/bash
# Copyright 2020 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
set -o errexit
set -o nounset
set -o pipefail
cleanup() {
if [[ "${KUBETEST_IN_DOCKER:-}" == "true" ]]; then
kind "export" logs --name ${KIND_CLUSTER_NAME} "${ARTIFACTS}/logs" || true
fi
kind delete cluster \
--name ${KIND_CLUSTER_NAME}
}
trap cleanup EXIT
if ! command -v kind --version &> /dev/null; then
echo "kind is not installed. Use the package manager or visit the official site https://kind.sigs.k8s.io/"
exit 1
fi
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
export K8S_VERSION=${K8S_VERSION:-v1.18.0@sha256:0e20578828edd939d25eb98496a685c76c98d54084932f76069f886ec315d694}
KIND_CLUSTER_NAME="ingress-nginx-dev"
echo "[dev-env] creating Kubernetes cluster with kind"
export KUBECONFIG="${HOME}/.kube/kind-config-${KIND_CLUSTER_NAME}"
kind create cluster \
--name ${KIND_CLUSTER_NAME} \
--config "${DIR}/kind.yaml" \
--retain \
--image "kindest/node:${K8S_VERSION}"
echo "Kubernetes cluster:"
kubectl get nodes -o wide
echo "[dev-env] running helm chart e2e tests..."
docker run --rm --interactive --network host \
--name ct \
--volume $KUBECONFIG:/root/.kube/config \
--volume "${DIR}/../../":/workdir \
--workdir /workdir \
quay.io/helmpack/chart-testing:v3.0.0-rc.1 ct install \
--charts charts/ingress-nginx \
--helm-extra-args "--timeout 120s"